'use strict';

exports.__esModule = true;
exports.create = create;
exports.get = get;

var _dom = require('../utils/dom');

var _nativeMethods = require('./native-methods');

var _nativeMethods2 = _interopRequireDefault(_nativeMethods);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SANDBOX_BACKUP = 'hammerhead|sandbox-backup';
function findRecord(storage, iframe) {
    for (var i = storage.length - 1; i >= 0; i--) {
        try {
            if (storage[i].iframe === iframe) return storage[i];
        } catch (e) {
            storage.splice(i, 1);
        }
    }
    return void 0;
}
function create(window, sandbox) {
    var topSameDomainWindow = (0, _dom.getTopSameDomainWindow)(window);
    var iframe = window !== topSameDomainWindow ? (0, _dom.getFrameElement)(window) : null;
    var storage = topSameDomainWindow[SANDBOX_BACKUP];
    if (!storage) {
        storage = [];
        _nativeMethods2.default.objectDefineProperty(topSameDomainWindow, SANDBOX_BACKUP, { value: storage });
    }
    var record = findRecord(storage, iframe);
    if (record) record.sandbox = sandbox;else storage.push({ iframe: iframe, sandbox: sandbox });
}
function get(window) {
    var topSameDomainWindow = (0, _dom.getTopSameDomainWindow)(window);
    var storage = topSameDomainWindow[SANDBOX_BACKUP];
    var iframe = window !== topSameDomainWindow ? window.frameElement : null;
    if (storage) {
        var record = findRecord(storage, iframe);
        return record ? record.sandbox : null;
    }
    return null;
}