'use strict';

exports.__esModule = true;

var _eventEmitter = require('../utils/event-emitter');

var _eventEmitter2 = _interopRequireDefault(_eventEmitter);

var _nativeMethods = require('./native-methods');

var _nativeMethods2 = _interopRequireDefault(_nativeMethods);

var _dom = require('../utils/dom');

var _internalProperties = require('../../processing/dom/internal-properties');

var _internalProperties2 = _interopRequireDefault(_internalProperties);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SandboxBase = function (_EventEmitter) {
    _inherits(SandboxBase, _EventEmitter);

    function SandboxBase() {
        _classCallCheck(this, SandboxBase);

        var _this = _possibleConstructorReturn(this, _EventEmitter.call(this));

        _this.window = null;
        _this.document = null;
        _this.nativeMethods = _nativeMethods2.default;
        return _this;
    }
    // NOTE: The sandbox is deactivated when its window is removed from the DOM.


    SandboxBase.prototype.isDeactivated = function isDeactivated() {
        try {
            // NOTE: In IE11, a situation when the document is not active may occur.
            // eslint-disable-next-line no-unused-expressions
            this.document.body;
            if (this.window[_internalProperties2.default.hammerhead]) {
                var frameElement = (0, _dom.getFrameElement)(this.window);
                return frameElement && !(0, _dom.isElementInDocument)(frameElement, (0, _dom.findDocument)(frameElement));
            }
        }
        // eslint-disable-next-line no-empty
        catch (e) {}
        return true;
    };

    SandboxBase.prototype.attach = function attach(window, document) {
        this.window = window;
        this.document = document || window.document;
    };

    return SandboxBase;
}(_eventEmitter2.default);

exports.default = SandboxBase;
module.exports = exports['default'];