'use strict';

exports.__esModule = true;
exports.getAnchorProperty = getAnchorProperty;
exports.setAnchorProperty = setAnchorProperty;
exports.dispose = dispose;

var _url = require('../../../utils/url');

var _nativeMethods = require('../../native-methods');

var _nativeMethods2 = _interopRequireDefault(_nativeMethods);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var anchor = _nativeMethods2.default.createElement.call(document, 'a');
var emptyAnchor = _nativeMethods2.default.createElement.call(document, 'a');
function getAnchorProperty(el, nativePropGetter) {
    var href = _nativeMethods2.default.anchorHrefGetter.call(el);
    if (href) {
        var parsedProxyUrl = (0, _url.parseProxyUrl)(href);
        _nativeMethods2.default.anchorHrefSetter.call(anchor, parsedProxyUrl ? parsedProxyUrl.destUrl : href);
        return nativePropGetter.call(anchor);
    }
    return nativePropGetter.call(emptyAnchor);
}
function setAnchorProperty(el, nativePropSetter, value) {
    var href = _nativeMethods2.default.anchorHrefGetter.call(el);
    if (href) {
        var parsedProxyUrl = (0, _url.parseProxyUrl)(href);
        _nativeMethods2.default.anchorHrefSetter.call(anchor, parsedProxyUrl ? parsedProxyUrl.destUrl : href);
        nativePropSetter.call(anchor, value);
        el.setAttribute('href', _nativeMethods2.default.anchorHrefGetter.call(anchor));
    }
    return value;
}
function dispose() {
    anchor = null;
    emptyAnchor = null;
}