'use strict';

exports.__esModule = true;

var _base = require('./base');

var _base2 = _interopRequireDefault(_base);

var _dom = require('../utils/dom');

var _nativeMethods = require('../sandbox/native-methods');

var _nativeMethods2 = _interopRequireDefault(_nativeMethods);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ConsoleSandbox = function (_SandboxBase) {
    _inherits(ConsoleSandbox, _SandboxBase);

    function ConsoleSandbox(messageSandbox) {
        _classCallCheck(this, ConsoleSandbox);

        var _this = _possibleConstructorReturn(this, _SandboxBase.call(this));

        _this.CONSOLE_METH_CALLED_EVENT = 'hammerhead|event|console-meth-called';
        _this.messageSandbox = messageSandbox;
        _this.serviceMsgReceivedEventCallback = function (_ref) {
            var message = _ref.message;

            if (message.cmd === _this.CONSOLE_METH_CALLED_EVENT) _this.emit(_this.CONSOLE_METH_CALLED_EVENT, { meth: message.meth, line: message.line });
        };
        return _this;
    }

    ConsoleSandbox.prototype._toString = function _toString(obj) {
        try {
            return String(obj);
        } catch (e) {
            return 'object';
        }
    };

    ConsoleSandbox.prototype._proxyConsoleMeth = function _proxyConsoleMeth(meth) {
        var _this2 = this;

        this.window.console[meth] = function () {
            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
            }

            if (!(0, _dom.isCrossDomainWindows)(window, window.top)) {
                var sendToTopWindow = window !== window.top;
                var line = _nativeMethods2.default.arrayMap.call(args, _this2._toString).join(' ');
                if (sendToTopWindow) {
                    _this2.emit(_this2.CONSOLE_METH_CALLED_EVENT, { meth: meth, line: line, inIframe: true });
                    _this2.messageSandbox.sendServiceMsg({ meth: meth, line: line, cmd: _this2.CONSOLE_METH_CALLED_EVENT }, window.top);
                } else _this2.emit(_this2.CONSOLE_METH_CALLED_EVENT, { meth: meth, line: line });
            }
            _this2.nativeMethods.consoleMeths[meth].apply(_this2.nativeMethods.console, args);
        };
    };

    ConsoleSandbox.prototype.attach = function attach(window) {
        _SandboxBase.prototype.attach.call(this, window);
        this._proxyConsoleMeth('log');
        this._proxyConsoleMeth('info');
        this._proxyConsoleMeth('error');
        this._proxyConsoleMeth('warn');
        var messageSandbox = this.messageSandbox;
        messageSandbox.on(messageSandbox.SERVICE_MSG_RECEIVED_EVENT, this.serviceMsgReceivedEventCallback);
    };

    return ConsoleSandbox;
}(_base2.default);

exports.default = ConsoleSandbox;
module.exports = exports['default'];