'use strict';

exports.__esModule = true;

var _base = require('./base');

var _base2 = _interopRequireDefault(_base);

var _script = require('../../processing/script');

var _destinationLocation = require('../utils/destination-location');

var destinationLocation = _interopRequireWildcard(_destinationLocation);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ElectronSandbox = function (_SandboxBase) {
    _inherits(ElectronSandbox, _SandboxBase);

    function ElectronSandbox() {
        _classCallCheck(this, ElectronSandbox);

        return _possibleConstructorReturn(this, _SandboxBase.apply(this, arguments));
    }

    ElectronSandbox._createFnWrapper = function _createFnWrapper(vm, nativeFn) {
        return function () {
            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
            }

            if (typeof args[0] === 'string') args[0] = (0, _script.processScript)(args[0]);
            return nativeFn.apply(vm, args);
        };
    };

    ElectronSandbox._overrideElectronModulePaths = function _overrideElectronModulePaths(window) {
        // NOTE: Need this to avoid Webmake require
        // eslint-disable-next-line no-eval
        var electronRequire = eval('require');
        var path = electronRequire('path');
        var destination = destinationLocation.getParsed();
        /*eslint-disable no-restricted-properties*/
        if (destination.protocol !== 'file:') return;
        var pathname = window.process.platform === 'win32' && destination.pathname[0] === '/' ? destination.pathname.substr(1) : destination.pathname;
        /*eslint-enable no-restricted-properties*/
        window.__filename = path.normalize(decodeURIComponent(pathname));
        window.__dirname = path.dirname(window.__filename);
        window.module.filename = window.__filename;
        window.module.paths = window.module.paths.concat(electronRequire('module')._nodeModulePaths(window.__dirname));
    };

    ElectronSandbox.prototype.attach = function attach(window) {
        _SandboxBase.prototype.attach.call(this, window);
        if (!window.require) return;
        var vm = window.require('vm');
        if (!vm) return;
        var nativeMethods = this.nativeMethods;
        if (nativeMethods.refreshElectronMeths(vm)) {
            vm.createScript = ElectronSandbox._createFnWrapper(vm, nativeMethods.createScript);
            vm.runInDebugContext = ElectronSandbox._createFnWrapper(vm, nativeMethods.runInDebugContext);
            vm.runInContext = ElectronSandbox._createFnWrapper(vm, nativeMethods.runInContext);
            vm.runInNewContext = ElectronSandbox._createFnWrapper(vm, nativeMethods.runInNewContext);
            vm.runInThisContext = ElectronSandbox._createFnWrapper(vm, nativeMethods.runInThisContext);
            ElectronSandbox._overrideElectronModulePaths(window);
        }
    };

    return ElectronSandbox;
}(_base2.default);

exports.default = ElectronSandbox;
module.exports = exports['default'];