'use strict';

exports.__esModule = true;

var _base = require('../base');

var _base2 = _interopRequireDefault(_base);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WINDOW_ACTIVATED_EVENT = 'hammerhead|event|window-activated';
var WINDOW_DEACTIVATED_EVENT = 'hammerhead|event|window-deactivated';

var ActiveWindowTracker = function (_SandboxBase) {
    _inherits(ActiveWindowTracker, _SandboxBase);

    function ActiveWindowTracker(messageSandbox) {
        _classCallCheck(this, ActiveWindowTracker);

        var _this = _possibleConstructorReturn(this, _SandboxBase.call(this));

        _this.messageSandbox = messageSandbox;
        _this.isIframeWindow = null;
        _this.activeWindow = null;
        _this.isActive = null;
        return _this;
    }

    ActiveWindowTracker.prototype._notifyPrevActiveWindow = function _notifyPrevActiveWindow() {
        try {
            if (this.activeWindow.top && this.activeWindow !== this.activeWindow.top) {
                this.messageSandbox.sendServiceMsg({
                    cmd: WINDOW_DEACTIVATED_EVENT
                }, this.activeWindow);
            }
        } catch (err) {
            // NOTE: The error appears in IE when the corresponding iframe is removed.
        }
    };

    ActiveWindowTracker.prototype.attach = function attach(window) {
        var _this2 = this;

        _SandboxBase.prototype.attach.call(this, window);
        this.isIframeWindow = window !== window.top;
        this.activeWindow = !this.isIframeWindow ? window.top : null;
        this.isActive = !this.isIframeWindow;
        this.messageSandbox.on(this.messageSandbox.SERVICE_MSG_RECEIVED_EVENT, function (e) {
            if (e.message.cmd === WINDOW_ACTIVATED_EVENT) {
                _this2._notifyPrevActiveWindow();
                _this2.isActive = false;
                _this2.activeWindow = e.source;
            } else if (e.message.cmd === WINDOW_DEACTIVATED_EVENT) _this2.isActive = false;
        });
    };

    ActiveWindowTracker.prototype.isCurrentWindowActive = function isCurrentWindowActive() {
        return this.isActive;
    };

    ActiveWindowTracker.prototype.makeCurrentWindowActive = function makeCurrentWindowActive() {
        this.isActive = true;
        if (!this.isIframeWindow) {
            this._notifyPrevActiveWindow();
            this.activeWindow = this.window;
        } else {
            this.messageSandbox.sendServiceMsg({
                cmd: WINDOW_ACTIVATED_EVENT
            }, this.window.top);
        }
    };

    return ActiveWindowTracker;
}(_base2.default);

exports.default = ActiveWindowTracker;
module.exports = exports['default'];