'use strict';

exports.__esModule = true;

var _nativeMethods = require('../../native-methods');

var _nativeMethods2 = _interopRequireDefault(_nativeMethods);

var _dataTransferItemKind = require('./data-transfer-item-kind');

var _dataTransferItemKind2 = _interopRequireDefault(_dataTransferItemKind);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// https://html.spec.whatwg.org/multipage/interaction.html#datatransferitem
var DataTransferItem = function DataTransferItem(kind, type, data) {
    _classCallCheck(this, DataTransferItem);

    _nativeMethods2.default.objectDefineProperty(this, 'kind', {
        enumerable: true,
        get: function get() {
            return kind;
        }
    });
    _nativeMethods2.default.objectDefineProperty(this, 'type', {
        enumerable: true,
        get: function get() {
            return type;
        }
    });
    _nativeMethods2.default.objectDefineProperty(this, 'getAsString', {
        configurable: true,
        enumerable: true,
        get: function get() {
            return function (callback) {
                if (!arguments.length) throw new Error("Failed to execute 'getAsString' on 'DataTransferItem': 1 argument required, but only 0 present.");
                if (typeof callback !== 'function') return;
                if (kind !== _dataTransferItemKind2.default.string) return;
                _nativeMethods2.default.setTimeout.call(window, function () {
                    return callback(data);
                }, 0);
            };
        }
    });
    _nativeMethods2.default.objectDefineProperty(this, 'getAsFile', {
        configurable: true,
        enumerable: true,
        get: function get() {
            return function () {
                if (kind !== _dataTransferItemKind2.default.file) return null;
                return data;
            };
        }
    });
};

exports.default = DataTransferItem;

if (_nativeMethods2.default.DataTransferItem) DataTransferItem.prototype = _nativeMethods2.default.DataTransferItem.prototype;
module.exports = exports['default'];