'use strict';

exports.__esModule = true;

var _base = require('./base');

var _base2 = _interopRequireDefault(_base);

var _browser = require('../utils/browser');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BROWSERTOOLS_CONSOLE_SAFEFUNC = '__BROWSERTOOLS_CONSOLE_SAFEFUNC';

var IEDebugSandbox = function (_SandboxBase) {
    _inherits(IEDebugSandbox, _SandboxBase);

    function IEDebugSandbox() {
        _classCallCheck(this, IEDebugSandbox);

        var _this = _possibleConstructorReturn(this, _SandboxBase.call(this));

        _this._isDebuggerInitiator = false;
        return _this;
    }

    IEDebugSandbox.prototype._createFuncWrapper = function _createFuncWrapper(func) {
        var _this2 = this;

        if (typeof func === 'function') {
            return function (fn, safeAssert) {
                var ieDebugSandbox = _this2;
                return function () {
                    ieDebugSandbox._isDebuggerInitiator = true;
                    try {
                        var result = fn(arguments);
                        ieDebugSandbox._isDebuggerInitiator = false;
                        return result;
                    } catch (e) {
                        safeAssert(e);
                    }
                    ieDebugSandbox._isDebuggerInitiator = false;
                };
            };
        }
        return func;
    };

    IEDebugSandbox.prototype.isDebuggerInitiator = function isDebuggerInitiator() {
        return this._isDebuggerInitiator;
    };

    IEDebugSandbox.prototype.attach = function attach(window) {
        var _this3 = this;

        if (!_browser.isIE) return;
        var descriptor = this.nativeMethods.objectGetOwnPropertyDescriptor(window, BROWSERTOOLS_CONSOLE_SAFEFUNC);
        var wrapper = void 0;
        if (!descriptor || descriptor.value) {
            // eslint-disable-line no-restricted-properties
            if (descriptor) wrapper = this._createFuncWrapper(descriptor.value); // eslint-disable-line no-restricted-properties
            this.nativeMethods.objectDefineProperty(window, BROWSERTOOLS_CONSOLE_SAFEFUNC, {
                set: function set(fn) {
                    wrapper = _this3._createFuncWrapper(fn);
                },
                get: function get() {
                    return wrapper;
                }
            });
        }
    };

    return IEDebugSandbox;
}(_base2.default);

exports.default = IEDebugSandbox;
module.exports = exports['default'];