'use strict';

exports.__esModule = true;

var _fnBind = require('../../../utils/fn-bind');

var _fnBind2 = _interopRequireDefault(_fnBind);

var _featureDetection = require('../../../utils/feature-detection');

var _index = require('./index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ATTRIBUTES_METHODS = ['setNamedItem', 'setNamedItemNS', 'removeNamedItem', 'removeNamedItemNS', 'getNamedItem', 'getNamedItemNS'];
function createMethodWrapper(el, attributes, method) {
    return function () {
        var result = attributes[method].apply(attributes, arguments);
        (0, _index.refreshAttributesWrapper)(el);
        return result;
    };
}

var AttributesWrapper = function AttributesWrapper(el, attributes) {
    var _this = this;

    _classCallCheck(this, AttributesWrapper);

    (0, _index.assignAttributes)(this, attributes);
    this.item = function (index) {
        return _this[index];
    };
    for (var field in attributes) {
        if (typeof this[field] === 'function' && field !== 'item') {
            this[field] = ATTRIBUTES_METHODS.indexOf(field) !== -1 ? createMethodWrapper(el, attributes, field) : (0, _fnBind2.default)(attributes[field], attributes);
        }
    }
    if (_featureDetection.attrGetNamedItemIsNotEnumerable) this['getNamedItem'] = createMethodWrapper(el, attributes, 'getNamedItem');
};

exports.default = AttributesWrapper;
module.exports = exports['default'];