'use strict';

exports.__esModule = true;

var _eventEmitter = require('../../utils/event-emitter');

var _eventEmitter2 = _interopRequireDefault(_eventEmitter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NodeMutation = function (_EventEmitter) {
    _inherits(NodeMutation, _EventEmitter);

    function NodeMutation() {
        _classCallCheck(this, NodeMutation);

        var _this = _possibleConstructorReturn(this, _EventEmitter.apply(this, arguments));

        _this.BEFORE_DOCUMENT_CLEANED_EVENT = 'hammerhead|event|before-document-cleaned';
        _this.DOCUMENT_CLEANED_EVENT = 'hammerhead|event|document-cleaned';
        _this.DOCUMENT_CLOSED_EVENT = 'hammerhead|event|document-closed';
        _this.BODY_CONTENT_CHANGED_EVENT = 'hammerhead|event|body-content-changed';
        _this.BODY_CREATED_EVENT = 'hammerhead|event|body-created';
        _this.IFRAME_ADDED_TO_DOM_EVENT = 'hammerhead|event|iframe-added-to-dom';
        return _this;
    }

    NodeMutation.prototype.onIframeAddedToDOM = function onIframeAddedToDOM(e) {
        this.emit(this.IFRAME_ADDED_TO_DOM_EVENT, e);
    };

    NodeMutation.prototype.onBeforeDocumentCleaned = function onBeforeDocumentCleaned(e) {
        this.emit(this.BEFORE_DOCUMENT_CLEANED_EVENT, e);
    };

    NodeMutation.prototype.onDocumentCleaned = function onDocumentCleaned(e) {
        this.emit(this.DOCUMENT_CLEANED_EVENT, e);
    };

    NodeMutation.prototype.onDocumentClosed = function onDocumentClosed(e) {
        this.emit(this.DOCUMENT_CLOSED_EVENT, e);
    };

    NodeMutation.prototype.onBodyContentChanged = function onBodyContentChanged(e) {
        this.emit(this.BODY_CONTENT_CHANGED_EVENT, e);
    };

    NodeMutation.prototype.onBodyCreated = function onBodyCreated(e) {
        this.emit(this.BODY_CREATED_EVENT, e);
    };

    return NodeMutation;
}(_eventEmitter2.default);

exports.default = NodeMutation;
module.exports = exports['default'];