'use strict';

exports.__esModule = true;

var _nativeMethods = require('../native-methods');

var _nativeMethods2 = _interopRequireDefault(_nativeMethods);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var FileListWrapper = function () {
    function FileListWrapper(fileList) {
        var _this = this;

        _classCallCheck(this, FileListWrapper);

        _nativeMethods2.default.objectDefineProperty(this, 'length', {
            get: function get() {
                return fileList.length;
            }
        });
        for (var i = 0; i < fileList.length; i++) {
            this[i] = FileListWrapper._createFileWrapper(fileList[i]);
        }this.item = function (index) {
            return _this[index];
        };
    }

    FileListWrapper._base64ToBlob = function _base64ToBlob(base64Data, mimeType, sliceSize) {
        mimeType = mimeType || '';
        sliceSize = sliceSize || 512;
        var byteCharacters = atob(base64Data);
        var byteArrays = [];
        for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
            var slice = byteCharacters.slice(offset, offset + sliceSize);
            var byteNumbers = new Array(slice.length);
            for (var i = 0; i < slice.length; i++) {
                byteNumbers[i] = slice.charCodeAt(i);
            }byteArrays.push(new Uint8Array(byteNumbers));
        }
        return new Blob(byteArrays, { type: mimeType });
    };

    FileListWrapper._createFileWrapper = function _createFileWrapper(fileInfo) {
        var wrapper = null;
        if (!window.Blob) {
            wrapper = {
                size: fileInfo.info.size,
                type: fileInfo.info.type
            };
        } else if (fileInfo.blob) wrapper = new Blob([fileInfo.blob], { type: fileInfo.info.type });else wrapper = FileListWrapper._base64ToBlob(fileInfo.data, fileInfo.info.type);
        wrapper.name = fileInfo.info.name;
        wrapper.lastModifiedDate = new Date(fileInfo.info.lastModifiedDate);
        wrapper.base64 = fileInfo.data;
        return wrapper;
    };

    return FileListWrapper;
}();
//@ts-ignore


exports.default = FileListWrapper;
if (window.FileList) FileListWrapper.prototype = FileList.prototype;
module.exports = exports['default'];