'use strict';

exports.__esModule = true;
exports.isElectron = exports.isWebKit = exports.isSafari = exports.isChrome = exports.isMSEdge = exports.isFirefox = exports.isIE9 = exports.isIE10 = exports.isIE11 = exports.isIE = exports.webkitVersion = exports.fullVersion = exports.version = exports.isTablet = exports.isMobile = exports.isIOS = exports.isAndroid = exports.isMacPlatform = exports.compareVersions = undefined;

var _bowser = require('bowser');

var _bowser2 = _interopRequireDefault(_bowser);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var userAgent = navigator.userAgent.toLowerCase();
//@ts-ignore
var info = _bowser2.default._detect(userAgent);
var webkitVersionMatch = userAgent.match(/applewebkit\/(\d+(:?\.\d+)*)/);
//Helper
//@ts-ignore
var compareVersions = exports.compareVersions = _bowser2.default.compareVersions;
//Platforms
var isMacPlatform = exports.isMacPlatform = !!info.mac;
var isAndroid = exports.isAndroid = !!info.android;
var isIOS = exports.isIOS = !!info.ios;
var isMobile = exports.isMobile = !!info.mobile;
var isTablet = exports.isTablet = !!info.tablet;
//Browsers
var version = exports.version = parseInt(info.version, 10);
var fullVersion = exports.fullVersion = info.version;
var webkitVersion = exports.webkitVersion = webkitVersionMatch && webkitVersionMatch[1] || '';
var isIE = exports.isIE = !!(info.msie || info.msedge);
var isIE11 = exports.isIE11 = isIE && version === 11;
var isIE10 = exports.isIE10 = isIE && version === 10;
var isIE9 = exports.isIE9 = isIE && version === 9;
var isFirefox = exports.isFirefox = !!info.firefox;
var isMSEdge = exports.isMSEdge = !!info.msedge;
var isChrome = exports.isChrome = !!info.chrome;
var isSafari = exports.isSafari = !!info.safari;
var isWebKit = exports.isWebKit = !!(info.webkit || info.blink);
var isElectron = exports.isElectron = /electron/g.test(userAgent);