'use strict';

exports.__esModule = true;
exports.hasPointerEvents = exports.DOM_EVENTS = exports.KEYBOARD_MODIFIERS_PARAMETER = exports.WHICH_PARAMETER = exports.BUTTONS_PARAMETER = exports.BUTTON = undefined;
exports.preventDefault = preventDefault;
exports.stopPropagation = stopPropagation;
exports.isObjectEventListener = isObjectEventListener;
exports.isValidEventListener = isValidEventListener;
exports.callEventListener = callEventListener;

var _nativeMethods = require('../sandbox/native-methods');

var _nativeMethods2 = _interopRequireDefault(_nativeMethods);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BUTTON = exports.BUTTON = {
    left: 0,
    middle: 1,
    right: 2
};
var BUTTONS_PARAMETER = exports.BUTTONS_PARAMETER = {
    noButton: 0,
    leftButton: 1,
    rightButton: 2
};
var WHICH_PARAMETER = exports.WHICH_PARAMETER = {
    noButton: 0,
    leftButton: 1,
    middleButton: 2,
    rightButton: 3
};
var KEYBOARD_MODIFIERS_PARAMETER = exports.KEYBOARD_MODIFIERS_PARAMETER = {
    altKey: 'Alt',
    ctrlKey: 'Control',
    shiftKey: 'Shift',
    metaKey: 'Meta'
};
var DOM_EVENTS = exports.DOM_EVENTS = ['click', 'mousedown', 'mouseup', 'dblclick', 'contextmenu', 'mousemove', 'mouseover', 'mouseout', 'touchstart', 'touchmove', 'touchend', 'keydown', 'keypress', 'textInput', 'textinput', 'input', 'keyup', 'change', 'focus', 'blur', 'MSPointerDown', 'MSPointerMove', 'MSPointerOver', 'MSPointerOut', 'MSPointerUp', 'pointerdown', 'pointermove', 'pointerover', 'pointerout', 'pointerup', 'focusin', 'focusout', 'mouseenter', 'mouseleave', 'pointerenter', 'pointerleave'];
function preventDefault(ev, allowBubbling) {
    if (ev.preventDefault) ev.preventDefault();else ev.returnValue = false;
    if (!allowBubbling) stopPropagation(ev);
}
function stopPropagation(ev) {
    if (ev.stopImmediatePropagation) ev.stopImmediatePropagation();else if (ev.stopPropagation) ev.stopPropagation();
    ev.cancelBubble = true;
}
function isObjectEventListener(listener) {
    return typeof listener === 'object' && listener && typeof listener.handleEvent === 'function';
}
function isValidEventListener(listener) {
    return typeof listener === 'function' || isObjectEventListener(listener);
}
function callEventListener(ctx, listener, e) {
    if (isObjectEventListener(listener)) return listener.handleEvent.call(listener, e);
    return listener.call(ctx, e);
}
var hasPointerEvents = exports.hasPointerEvents = !!(_nativeMethods2.default.WindowPointerEvent || _nativeMethods2.default.WindowMSPointerEvent);