'use strict';

exports.__esModule = true;
exports.getElementsByNameReturnsHTMLCollection = exports.attrGetNamedItemIsNotEnumerable = exports.hasDataTransfer = exports.isTouchDevice = exports.hasTouchPoints = exports.hasTouchEvents = exports.instanceAndPrototypeToStringAreEqual = exports.emptyActionAttrFallbacksToTheLocation = undefined;

var _nativeMethods = require('../sandbox/native-methods');

var _nativeMethods2 = _interopRequireDefault(_nativeMethods);

var _browser = require('./browser');

var browserUtils = _interopRequireWildcard(_browser);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var form = _nativeMethods2.default.createElement.call(document, 'form');
var elements = _nativeMethods2.default.getElementsByName.call(document, '');
// NOTE: In some browsers, elements without the url attribute return the location url
// when accessing this attribute directly. See form.action in Edge 25 as an example.
var emptyActionAttrFallbacksToTheLocation = exports.emptyActionAttrFallbacksToTheLocation = _nativeMethods2.default.formActionGetter.call(form) === window.location.toString();
// NOTE: In Chrome, toString(window) equals '[object Window]' and toString(Window.prototype) equals '[object Blob]',
// this condition is also satisfied for Blob, Document, XMLHttpRequest, etc
var instanceAndPrototypeToStringAreEqual = exports.instanceAndPrototypeToStringAreEqual = _nativeMethods2.default.objectToString.call(window) === _nativeMethods2.default.objectToString.call(Window.prototype);
var hasTouchEvents = exports.hasTouchEvents = 'ontouchstart' in window;
// NOTE: We need to check touch points only for IE, because it has PointerEvent and MSPointerEvent (IE10, IE11)
// instead of TouchEvent (T109295).
var hasTouchPoints = exports.hasTouchPoints = browserUtils.isIE && (navigator.maxTouchPoints > 0 || navigator.msMaxTouchPoints > 0);
var isTouchDevice = exports.isTouchDevice = (browserUtils.isMobile || browserUtils.isTablet) && hasTouchEvents;
// @ts-ignore
var hasDataTransfer = exports.hasDataTransfer = !!window.DataTransfer;
// NOTE: In the Edge 17, the getNamedItem method of attributes object is not enumerable
var attrGetNamedItemIsNotEnumerable = exports.attrGetNamedItemIsNotEnumerable = _nativeMethods2.default.objectGetOwnPropertyDescriptor
// @ts-ignore
.call(window.Object, NamedNodeMap.prototype, 'getNamedItem');
// Both IE and Edge return an HTMLCollection, not a NodeList
// @ts-ignore
var getElementsByNameReturnsHTMLCollection = exports.getElementsByNameReturnsHTMLCollection = _nativeMethods2.default.objectGetPrototypeOf.call(window.Object, elements) === _nativeMethods2.default.HTMLCollection.prototype;