"use strict";

exports.__esModule = true;
exports.default = createIntegerIdGenerator;
var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || 9007199254740991;
var MIN_SAFE_INTEGER = Number.MIN_SAFE_INTEGER || -9007199254740991;
function createIntegerIdGenerator() {
    var id = MIN_SAFE_INTEGER;
    return {
        increment: function increment() {
            id = id === MAX_SAFE_INTEGER ? MIN_SAFE_INTEGER : id + 1;
            return id;
        },
        get value() {
            return id;
        }
    };
}
module.exports = exports['default'];