'use strict';

exports.__esModule = true;
exports.getNativeQuerySelector = getNativeQuerySelector;
exports.getNativeQuerySelectorAll = getNativeQuerySelectorAll;

var _nativeMethods = require('../sandbox/native-methods');

var _nativeMethods2 = _interopRequireDefault(_nativeMethods);

var _dom = require('./dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getNativeQuerySelector(el) {
    if ((0, _dom.isDomElement)(el)) return _nativeMethods2.default.elementQuerySelector;
    return (0, _dom.isDocumentFragmentNode)(el) || (0, _dom.isShadowRoot)(el) ? _nativeMethods2.default.documentFragmentQuerySelector : _nativeMethods2.default.querySelector;
}
function getNativeQuerySelectorAll(el) {
    // NOTE: Do not return the isDocument function instead of the isDomElement
    // it leads to the `Invalid calling object` error in some cases in IE11 (GH-1846)
    if ((0, _dom.isDomElement)(el)) return _nativeMethods2.default.elementQuerySelectorAll;
    return (0, _dom.isDocumentFragmentNode)(el) || (0, _dom.isShadowRoot)(el) ? _nativeMethods2.default.documentFragmentQuerySelectorAll : _nativeMethods2.default.querySelectorAll;
}